

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Firewall Data Access to Safety Core &mdash; TISCI User Guide</title>
  

  
  
    <link rel="shortcut icon" href="../_static/favicon.ico"/>
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  

  
    <link rel="stylesheet" href="../_static/theme_overrides.css" type="text/css" />
  

  
        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../index.html"/>
        <link rel="up" title="Chapter 6: Topic User Guides" href="index.html"/>
        <link rel="next" title="Boot Mode Writer Service" href="boot_mode_writer.html"/>
        <link rel="prev" title="Cryptographic Services" href="csp.html"/> 

  
  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../index.html" class="icon icon-home"> TISCI
          

          
          </a>

          
            
            
              <div class="version">
                11.00.04
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="../2_tisci_msgs/index.html">Chapter 2: TISCI Message Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Chapter 6: Topic User Guides</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="authentication.html">System Firmware Authentication and Decryption Requests</a></li>
<li class="toctree-l2"><a class="reference internal" href="devgrp_usage.html">Device Group Primer</a></li>
<li class="toctree-l2"><a class="reference internal" href="domgrp_usage.html">Domain Group Primer</a></li>
<li class="toctree-l2"><a class="reference internal" href="secure_boot_signing.html">Signing binaries for Secure Boot on HS Devices</a></li>
<li class="toctree-l2"><a class="reference internal" href="hs_boardcfg_signing.html">Signing Board Configuration on HS devices</a></li>
<li class="toctree-l2"><a class="reference internal" href="openssl_usage.html">Using OpenSSL for certificate creation</a></li>
<li class="toctree-l2"><a class="reference internal" href="extended_otp.html">Using Extended OTP</a></li>
<li class="toctree-l2"><a class="reference internal" href="dkek_management.html">Using Derived KEK on HS devices</a></li>
<li class="toctree-l2"><a class="reference internal" href="firewall_faq.html">Firewall FAQ</a></li>
<li class="toctree-l2"><a class="reference internal" href="saul_access.html">SAUL Access Outside of SYSFW</a></li>
<li class="toctree-l2"><a class="reference internal" href="security_handover.html">Performing Security Handover</a></li>
<li class="toctree-l2"><a class="reference internal" href="secure_debug.html">Secure Debug User Guide</a></li>
<li class="toctree-l2"><a class="reference internal" href="key_writer.html">Key  Writer</a></li>
<li class="toctree-l2"><a class="reference internal" href="otp_revision.html">Run time read/write to KEYREV and SWREV</a></li>
<li class="toctree-l2"><a class="reference internal" href="keyring.html">Keyring Management</a></li>
<li class="toctree-l2"><a class="reference internal" href="csp.html">Cryptographic Services</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Firewall Data Access to Safety Core</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#design">Design</a></li>
<li class="toctree-l3"><a class="reference internal" href="#steps-for-firewall-read-access-enablement-in-safety-core">Steps for firewall read access enablement in safety core</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#update-tifs-board-configuration-to-enable-firewall-config-read-access">Update TIFS board configuration to enable Firewall config read access.</a></li>
<li class="toctree-l4"><a class="reference internal" href="#call-tisci-api-tisci-msg-allow-fwl-ctrl-read">Call TISCI API - TISCI_MSG_ALLOW_FWL_CTRL_READ</a></li>
<li class="toctree-l4"><a class="reference internal" href="#read-firewall-and-isc-configuration-data-using-the-safety-checker-library-api">Read firewall and isc configuration data using the Safety Checker library API</a></li>
<li class="toctree-l4"><a class="reference internal" href="#call-tisci-api-tisci-msg-forbid-fwl-ctrl-read">Call TISCI API - TISCI_MSG_FORBID_FWL_CTRL_READ</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#reading-the-firewall-and-isc-data-in-the-safety-core">Reading the firewall and isc data in the Safety core</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="boot_mode_writer.html">Boot Mode Writer Service</a></li>
<li class="toctree-l2"><a class="reference internal" href="boot_mode_writer_encoding.html">Boot Mode Writer Encoding table</a></li>
</ul>
</li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../index.html">TISCI</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../index.html">Docs</a> &raquo;</li>
      
          <li><a href="index.html">Chapter 6: Topic User Guides</a> &raquo;</li>
      
    <li>Firewall Data Access to Safety Core</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="firewall-data-access-to-safety-core">
<h1>Firewall Data Access to Safety Core<a class="headerlink" href="#firewall-data-access-to-safety-core" title="Permalink to this headline">¶</a></h1>
<div class="contents local topic" id="table-of-contents">
<p class="topic-title">Table of Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#design" id="id2">Design</a></li>
<li><a class="reference internal" href="#steps-for-firewall-read-access-enablement-in-safety-core" id="id3">Steps for firewall read access enablement in safety core</a><ul>
<li><a class="reference internal" href="#update-tifs-board-configuration-to-enable-firewall-config-read-access" id="id4">Update TIFS board configuration to enable Firewall config read access.</a></li>
<li><a class="reference internal" href="#call-tisci-api-tisci-msg-allow-fwl-ctrl-read" id="id5">Call TISCI API - TISCI_MSG_ALLOW_FWL_CTRL_READ</a></li>
<li><a class="reference internal" href="#read-firewall-and-isc-configuration-data-using-the-safety-checker-library-api" id="id6">Read firewall and isc configuration data using the Safety Checker library API</a></li>
<li><a class="reference internal" href="#call-tisci-api-tisci-msg-forbid-fwl-ctrl-read" id="id7">Call TISCI API - TISCI_MSG_FORBID_FWL_CTRL_READ</a></li>
</ul>
</li>
<li><a class="reference internal" href="#reading-the-firewall-and-isc-data-in-the-safety-core" id="id8">Reading the firewall and isc data in the Safety core</a></li>
</ul>
</div>
<div class="section" id="design">
<span id="dref-fwl-access-safety-core-design"></span><h2><a class="toc-backref" href="#id2">Design</a><a class="headerlink" href="#design" title="Permalink to this headline">¶</a></h2>
<p>Firewall data region is opened up for the safety core to read, in order to monitor the firewall configuration in the registers.</p>
<p>The Safety Application shall</p>
<ul class="simple">
<li>Include the safety host information in the board configuration.</li>
<li>Call a TISCI API to TIFS, to open up the firewall read access to it.</li>
<li>Read the firewall data region via the Safety Checker API (running in the Safety Core)
for generating the golden reference and for periodic validation.</li>
<li>Call a TISCI API to TIFS, to forbid the firewall read access to itself, when the monitoring of the firewall data is no longer required.</li>
</ul>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Note: Security firewalls (firewall IDs 512-1023) are not allowed read access through this API.</p>
</div>
</div>
<div class="section" id="steps-for-firewall-read-access-enablement-in-safety-core">
<span id="dref-fwl-access-safety-core-steps"></span><h2><a class="toc-backref" href="#id3">Steps for firewall read access enablement in safety core</a><a class="headerlink" href="#steps-for-firewall-read-access-enablement-in-safety-core" title="Permalink to this headline">¶</a></h2>
<div class="section" id="update-tifs-board-configuration-to-enable-firewall-config-read-access">
<h3><a class="toc-backref" href="#id4">Update TIFS board configuration to enable Firewall config read access.</a><a class="headerlink" href="#update-tifs-board-configuration-to-enable-firewall-config-read-access" title="Permalink to this headline">¶</a></h3>
<p>Board configuration must be updated with the safety host information in the safety_host_info field of the</p>
<p>SAUL / Safety configuration.</p>
<p>This entry controls the SAUL / Safety configuration on the SOC.</p>
<table border="1" class="docutils" id="id1">
<caption><span class="caption-number">Table 7 </span><span class="caption-text">SA2UL / Safety Configuration</span><a class="headerlink" href="#id1" title="Permalink to this table">¶</a></caption>
<colgroup>
<col width="29%" />
<col width="27%" />
<col width="44%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Element</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>subhdr</td>
<td>boardcfg substructure header</td>
<td>Magic and size for integrity check</td>
</tr>
<tr class="row-odd"><td>boardcfg substructure header</td>
<td>u8</td>
<td>ID of the host allowed to acquire/release the
authentication resources. This feature is not
currently supported</td>
</tr>
<tr class="row-even"><td>Magic and size for
integrity check</td>
<td>u8</td>
<td>Flag for allowing pairing requests from PSIL.
Set to 0x5A to enable</td>
</tr>
<tr class="row-odd"><td>safety_host_info</td>
<td>u8[2]</td>
<td>{0x5AU, host id of Safety core}. For ex:
Host ID of R5 (pulsar_0) in J784S4 = 0x4
Host ID of WKUP R5 in AM62x      = 0x23</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="call-tisci-api-tisci-msg-allow-fwl-ctrl-read">
<h3><a class="toc-backref" href="#id5">Call TISCI API - TISCI_MSG_ALLOW_FWL_CTRL_READ</a><a class="headerlink" href="#call-tisci-api-tisci-msg-allow-fwl-ctrl-read" title="Permalink to this headline">¶</a></h3>
<p>Call the TISCI API - TISCI_MSG_ALLOW_FWL_CTRL_READ to request the read access of the firewall configuration region to the safety core.</p>
</div>
<div class="section" id="read-firewall-and-isc-configuration-data-using-the-safety-checker-library-api">
<h3><a class="toc-backref" href="#id6">Read firewall and isc configuration data using the Safety Checker library API</a><a class="headerlink" href="#read-firewall-and-isc-configuration-data-using-the-safety-checker-library-api" title="Permalink to this headline">¶</a></h3>
<p>Once the read access to the firewall configuration region is granted to the safety core, the firewall configuration data can be read
in the safety core (via API call to the Safety Checker library API - implemented using the formula explained in the section -
<a class="reference internal" href="#dref-secfwl-access-safety-core-func-reading"><span class="std std-ref">Reading the firewall and isc data in the Safety core</span></a></p>
</div>
<div class="section" id="call-tisci-api-tisci-msg-forbid-fwl-ctrl-read">
<h3><a class="toc-backref" href="#id7">Call TISCI API - TISCI_MSG_FORBID_FWL_CTRL_READ</a><a class="headerlink" href="#call-tisci-api-tisci-msg-forbid-fwl-ctrl-read" title="Permalink to this headline">¶</a></h3>
<p>Call the TISCI API -  TISCI_MSG_FORBID_FWL_CTRL_READ to disable the read access of the firewall configuration region to the safety core.</p>
</div>
</div>
<div class="section" id="reading-the-firewall-and-isc-data-in-the-safety-core">
<span id="dref-secfwl-access-safety-core-func-reading"></span><h2><a class="toc-backref" href="#id8">Reading the firewall and isc data in the Safety core</a><a class="headerlink" href="#reading-the-firewall-and-isc-data-in-the-safety-core" title="Permalink to this headline">¶</a></h2>
<p>Firewall Data of a particular firewall ID and region can be then read directly from the safety core.
ISC configuration data for a given ISC ID can also be read directly from the safety core.
Firewall data of a given ID and contains 32 bytes for each region.</p>
<p>For getting the firewall data of a given Firewall ID and a given region, the safety checker needs to read 32 bytes from the firewall region offset.</p>
<p>The firewall region offset can be calculated using the below formula:</p>
<p>Firewall base address + (ID x 1024) + (Region#  x 32)</p>
<p>For eg:</p>
<p>In J784S4, to calculate the firewall region offset of firewall Id 10, region 2,  read 32 bytes from below address -</p>
<p>0x45000000 + (10 x 1024) + (2 x 32) = 0x45002840</p>
<p>ISC data can also be calculated similarly using the above formula with ISC base address as 0x45800000.</p>
</div>
</div>


           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="boot_mode_writer.html" class="btn btn-neutral float-right" title="Boot Mode Writer Service" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="csp.html" class="btn btn-neutral" title="Cryptographic Services" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2025</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div> 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'11.00.04',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>

  

  
  
    <script type="text/javascript" src="../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>
   

</body>
</html>